Index: test/sasdataloader/test/utest_abs_reader.py
===================================================================
--- test/sasdataloader/test/utest_abs_reader.py	(revision 371b9e2fdd394f51668cf12a42d9872e6f8698d8)
+++ test/sasdataloader/test/utest_abs_reader.py	(revision 371b9e2fdd394f51668cf12a42d9872e6f8698d8)
@@ -2,4 +2,5 @@
     Unit tests for data manipulations
 """
+from __future__ import print_function
 
 import unittest
@@ -7,16 +8,23 @@
 from sas.sascalc.dataloader.loader import Loader
 from sas.sascalc.dataloader.readers.IgorReader import Reader as IgorReader
-from sas.sascalc.dataloader.readers.abs_reader import Reader as ABSReader
-
-
-class ABSReaderTests(unittest.TestCase):
-    
+from sas.sascalc.dataloader.readers.abs_reader import Reader as AbsReader
+from sas.sascalc.dataloader.readers.hfir1d_reader import Reader as HFIRReader
+from sas.sascalc.dataloader.readers.danse_reader import Reader as DANSEReader
+from sas.sascalc.dataloader.readers.cansas_reader import Reader as CANSASReader
+
+from sas.sascalc.dataloader.data_info import Data1D
+
+import os.path
+
+
+class abs_reader(unittest.TestCase):
+
     def setUp(self):
-        self.data_list = ABSReader().read("jan08002.ABS")
-        self.data = self.data_list[0]
-        
+        reader = AbsReader()
+        self.data = reader.read("jan08002.ABS")
+
     def test_abs_checkdata(self):
         """
-            Check the data content to see whether 
+            Check the data content to see whether
             it matches the specific file we loaded.
             Check the units too to see whether the
@@ -26,13 +34,13 @@
         self.assertEqual(self.data.filename, "jan08002.ABS")
         self.assertEqual(self.data.meta_data['loader'], "IGOR 1D")
-        
+
         self.assertEqual(self.data.source.wavelength_unit, 'A')
         self.assertEqual(self.data.source.wavelength, 6.0)
-        
+
         self.assertEqual(self.data.detector[0].distance_unit, 'mm')
         self.assertEqual(self.data.detector[0].distance, 1000.0)
-        
+
         self.assertEqual(self.data.sample.transmission, 0.5667)
-        
+
         self.assertEqual(self.data.detector[0].beam_center_unit, 'mm')
         center_x = 114.58*5.08
@@ -40,5 +48,5 @@
         self.assertEqual(self.data.detector[0].beam_center.x, center_x)
         self.assertEqual(self.data.detector[0].beam_center.y, center_y)
-        
+
         self.assertEqual(self.data.y_unit, '1/cm')
         self.assertEqual(self.data.x[0], 0.002618)
@@ -46,27 +54,33 @@
         self.assertEqual(self.data.x[2], 0.01309)
         self.assertEqual(self.data.x[126], 0.5828)
-        
+
         self.assertEqual(self.data.y[0], 0.02198)
         self.assertEqual(self.data.y[1], 0.02201)
         self.assertEqual(self.data.y[2], 0.02695)
         self.assertEqual(self.data.y[126], 0.2958)
-        
+
         self.assertEqual(self.data.dy[0], 0.002704)
         self.assertEqual(self.data.dy[1], 0.001643)
         self.assertEqual(self.data.dy[2], 0.002452)
         self.assertEqual(self.data.dy[126], 1)
-        
+
     def test_checkdata2(self):
         self.assertEqual(self.data.dy[126], 1)
 
-
-class HFIRReaderTests(unittest.TestCase):
+    def test_generic_loader(self):
+        # the generic loader should work as well
+        data = Loader().load("jan08002.ABS")
+        self.assertEqual(data.meta_data['loader'], "IGOR 1D")
+
+
+class hfir_reader(unittest.TestCase):
 
     def setUp(self):
-        self.data = Loader().load("S2-30dq.d1d")
+        reader = HFIRReader()
+        self.data = reader.read("S2-30dq.d1d")
 
     def test_hfir_checkdata(self):
         """
-            Check the data content to see whether 
+            Check the data content to see whether
             it matches the specific file we loaded.
         """
@@ -76,5 +90,5 @@
         self.assertEqual(len(self.data.x), 134)
         self.assertEqual(len(self.data.y), 134)
-        #          Q           I               dI          dQ  
+        #          Q           I               dI          dQ
         # Point 1: 0.003014    0.003010        0.000315    0.008249
         self.assertEqual(self.data.x[1], 0.003014)
@@ -83,13 +97,21 @@
         self.assertEqual(self.data.dx[1], 0.008249)
 
-
-class DanseReaderTests(unittest.TestCase):
-    
+    def test_generic_loader(self):
+        # the generic loader should work as well
+        data = Loader().load("S2-30dq.d1d")
+        self.assertEqual(data.meta_data['loader'], "HFIR 1D")
+
+
+class igor_reader(unittest.TestCase):
+
     def setUp(self):
-        self.data = Loader().load("MP_New.sans")
-
-    def test_checkdata(self):
-        """
-            Check the data content to see whether 
+        # the IgorReader should be able to read this filetype
+        # if it can't, stop here.
+        reader = IgorReader()
+        self.data = reader.read("MAR07232_rest.ASC")
+
+    def test_igor_checkdata(self):
+        """
+            Check the data content to see whether
             it matches the specific file we loaded.
             Check the units too to see whether the
@@ -97,13 +119,60 @@
             tests won't pass
         """
+        self.assertEqual(self.data.filename, "MAR07232_rest.ASC")
+        self.assertEqual(self.data.meta_data['loader'], "IGOR 2D")
+
+        self.assertEqual(self.data.source.wavelength_unit, 'A')
+        self.assertEqual(self.data.source.wavelength, 8.4)
+
+        self.assertEqual(self.data.detector[0].distance_unit, 'mm')
+        self.assertEqual(self.data.detector[0].distance, 13705)
+
+        self.assertEqual(self.data.sample.transmission, 0.84357)
+
+        self.assertEqual(self.data.detector[0].beam_center_unit, 'mm')
+        center_x = (68.76 - 1)*5.0
+        center_y = (62.47 - 1)*5.0
+        self.assertEqual(self.data.detector[0].beam_center.x, center_x)
+        self.assertEqual(self.data.detector[0].beam_center.y, center_y)
+
+        self.assertEqual(self.data.I_unit, '1/cm')
+        # 3 points should be suffcient to check that the data is in column
+        # major order.
+        np.testing.assert_almost_equal(self.data.data[0:3],
+                                       [0.279783, 0.28951, 0.167634])
+        np.testing.assert_almost_equal(self.data.qx_data[0:3],
+                                       [-0.01849072, -0.01821785, -0.01794498])
+        np.testing.assert_almost_equal(self.data.qy_data[0:3],
+                                       [-0.01677435, -0.01677435, -0.01677435])
+
+    def test_generic_loader(self):
+        # the generic loader should direct the file to IgorReader as well
+        data = Loader().load("MAR07232_rest.ASC")
+        self.assertEqual(data.meta_data['loader'], "IGOR 2D")
+
+
+class DanseReaderTests(unittest.TestCase):
+
+    def setUp(self):
+        reader = DANSEReader()
+        self.data = reader.read("MP_New.sans")
+
+    def test_checkdata(self):
+        """
+            Check the data content to see whether
+            it matches the specific file we loaded.
+            Check the units too to see whether the
+            Data1D defaults changed. Otherwise the
+            tests won't pass
+        """
         self.assertEqual(self.data.filename, "MP_New.sans")
         self.assertEqual(self.data.meta_data['loader'], "DANSE")
-        
+
         self.assertEqual(self.data.source.wavelength_unit, 'A')
         self.assertEqual(self.data.source.wavelength, 7.5)
-        
+
         self.assertEqual(self.data.detector[0].distance_unit, 'mm')
         self.assertAlmostEqual(self.data.detector[0].distance, 5414.99, 3)
-        
+
         self.assertEqual(self.data.detector[0].beam_center_unit, 'mm')
         center_x = 68.74*5.0
@@ -111,5 +180,5 @@
         self.assertEqual(self.data.detector[0].beam_center.x, center_x)
         self.assertEqual(self.data.detector[0].beam_center.y, center_y)
-        
+
         self.assertEqual(self.data.I_unit, '1/cm')
         self.assertEqual(self.data.data[0], 1.57831)
@@ -121,18 +190,29 @@
         self.assertEqual(self.data.err_data[2], 2.06313)
 
- 
+    def test_generic_loader(self):
+        # the generic loader should work as well
+        data = Loader().load("MP_New.sans")
+        self.assertEqual(data.meta_data['loader'], "DANSE")
+
+
 class cansas_reader(unittest.TestCase):
-    
+
     def setUp(self):
+        reader = CANSASReader()
+        data = reader.read("cansas1d.xml")
+        self.data = data[0]
+
+    def test_generic_loader(self):
+        # the generic loader should work as well
         data = Loader().load("cansas1d.xml")
-        self.data = data[0]
- 
+        self.assertEqual(data[0].meta_data['loader'], "CanSAS XML 1D")
+
     def test_cansas_checkdata(self):
         self.assertEqual(self.data.filename, "cansas1d.xml")
         self._checkdata()
-        
+
     def _checkdata(self):
         """
-            Check the data content to see whether 
+            Check the data content to see whether
             it matches the specific file we loaded.
             Check the units too to see whether the
@@ -140,8 +220,7 @@
             tests won't pass
         """
-        
         self.assertEqual(self.data.run[0], "1234")
         self.assertEqual(self.data.meta_data['loader'], "CanSAS XML 1D")
-        
+
         # Data
         self.assertEqual(len(self.data.x), 2)
@@ -158,5 +237,5 @@
         self.assertEqual(self.data.run_name['1234'], 'run name')
         self.assertEqual(self.data.title, "Test title")
-        
+
         # Sample info
         self.assertEqual(self.data.sample.ID, "SI600-new-long")
@@ -164,7 +243,7 @@
         self.assertEqual(self.data.sample.thickness_unit, 'mm')
         self.assertAlmostEqual(self.data.sample.thickness, 1.03)
-        
+
         self.assertAlmostEqual(self.data.sample.transmission, 0.327)
-        
+
         self.assertEqual(self.data.sample.temperature_unit, 'C')
         self.assertEqual(self.data.sample.temperature, 0)
@@ -178,23 +257,23 @@
         self.assertAlmostEqual(self.data.sample.orientation.y, 0.02, 6)
 
-        self.assertEqual(self.data.sample.details[0], "http://chemtools.chem.soton.ac.uk/projects/blog/blogs.php/bit_id/2720") 
-        self.assertEqual(self.data.sample.details[1], "Some text here") 
-        
+        self.assertEqual(self.data.sample.details[0], "http://chemtools.chem.soton.ac.uk/projects/blog/blogs.php/bit_id/2720")
+        self.assertEqual(self.data.sample.details[1], "Some text here")
+
         # Instrument info
         self.assertEqual(self.data.instrument, "canSAS instrument")
-        
+
         # Source
         self.assertEqual(self.data.source.radiation, "neutron")
-        
+
         self.assertEqual(self.data.source.beam_size_unit, "mm")
         self.assertEqual(self.data.source.beam_size_name, "bm")
         self.assertEqual(self.data.source.beam_size.x, 12)
         self.assertEqual(self.data.source.beam_size.y, 13)
-        
+
         self.assertEqual(self.data.source.beam_shape, "disc")
-        
+
         self.assertEqual(self.data.source.wavelength_unit, "A")
         self.assertEqual(self.data.source.wavelength, 6)
-        
+
         self.assertEqual(self.data.source.wavelength_max_unit, "nm")
         self.assertAlmostEqual(self.data.source.wavelength_max, 1.0)
@@ -203,5 +282,5 @@
         self.assertEqual(self.data.source.wavelength_spread_unit, "percent")
         self.assertEqual(self.data.source.wavelength_spread, 14.3)
-        
+
         # Collimation
         _found1 = False
@@ -209,47 +288,47 @@
         self.assertEqual(self.data.collimation[0].length, 123.)
         self.assertEqual(self.data.collimation[0].name, 'test coll name')
-        
+
         for item in self.data.collimation[0].aperture:
             self.assertEqual(item.size_unit,'mm')
             self.assertEqual(item.distance_unit,'mm')
 
-            if item.size.x==50 \
-                and item.distance==11000.0 \
-                and item.name=='source' \
-                and item.type=='radius':
+            if item.size.x == 50 \
+                and item.distance == 11000.0 \
+                and item.name == 'source' \
+                and item.type == 'radius':
                 _found1 = True
-            elif item.size.x==1.0 \
-                and item.name=='sample' \
-                and item.type=='radius':
+            elif item.size.x == 1.0 \
+                and item.name == 'sample' \
+                and item.type == 'radius':
                 _found2 = True
-                
-        if _found1==False or _found2==False:
-            raise RuntimeError, "Could not find all data %s %s" % (_found1, _found2) 
-            
+
+        if _found1 == False or _found2 == False:
+            raise RuntimeError, "Could not find all data %s %s" % (_found1, _found2)
+
         # Detector
         self.assertEqual(self.data.detector[0].name, "fictional hybrid")
         self.assertEqual(self.data.detector[0].distance_unit, "mm")
         self.assertEqual(self.data.detector[0].distance, 4150)
-        
+
         self.assertEqual(self.data.detector[0].orientation_unit, "degree")
         self.assertAlmostEqual(self.data.detector[0].orientation.x, 1.0, 6)
         self.assertEqual(self.data.detector[0].orientation.y, 0.0)
         self.assertEqual(self.data.detector[0].orientation.z, 0.0)
-        
+
         self.assertEqual(self.data.detector[0].offset_unit, "m")
         self.assertEqual(self.data.detector[0].offset.x, .001)
         self.assertEqual(self.data.detector[0].offset.y, .002)
         self.assertEqual(self.data.detector[0].offset.z, None)
-        
+
         self.assertEqual(self.data.detector[0].beam_center_unit, "mm")
         self.assertEqual(self.data.detector[0].beam_center.x, 322.64)
         self.assertEqual(self.data.detector[0].beam_center.y, 327.68)
         self.assertEqual(self.data.detector[0].beam_center.z, None)
-        
+
         self.assertEqual(self.data.detector[0].pixel_size_unit, "mm")
         self.assertEqual(self.data.detector[0].pixel_size.x, 5)
         self.assertEqual(self.data.detector[0].pixel_size.y, 5)
         self.assertEqual(self.data.detector[0].pixel_size.z, None)
-        
+
         # Process
         _found_term1 = False
@@ -259,25 +338,21 @@
             self.assertTrue(item.date in ['04-Sep-2007 18:35:02',
                                           '03-SEP-2006 11:42:47'])
-            print item.term
+            print(item.term)
             for t in item.term:
-                if t['name']=="ABS:DSTAND" \
-                    and t['unit']=='mm' \
-                    and float(t['value'])==1.0:
+                if (t['name'] == "ABS:DSTAND"
+                    and t['unit'] == 'mm'
+                    and float(t['value']) == 1.0):
                     _found_term2 = True
-                elif t['name']=="radialstep" \
-                    and t['unit']=='mm' \
-                    and float(t['value'])==10.0:
+                elif (t['name'] == "radialstep"
+                      and t['unit'] == 'mm'
+                      and float(t['value']) == 10.0):
                     _found_term1 = True
-                    
-        if _found_term1==False or _found_term2==False:
+
+        if _found_term1 == False or _found_term2 == False:
             raise RuntimeError, "Could not find all process terms %s %s" % (_found_term1, _found_term2)
 
     def test_writer(self):
-        from sas.sascalc.dataloader.readers.cansas_reader import Reader
-        r = Reader()
-        x = np.ones(5)
-        y = np.ones(5)
-        dy = np.ones(5)
-        
+        r = CANSASReader()
+
         filename = "write_test.xml"
         r.write(filename, self.data)
@@ -286,4 +361,6 @@
         self.assertEqual(self.data.filename, filename)
         self._checkdata()
+        if os.path.isfile(filename):
+            os.remove(filename)
 
     def test_units(self):
@@ -293,5 +370,5 @@
         """
         filename = "cansas1d_units.xml"
-        data = Loader().load(filename)
+        data = CANSASReader().read(filename)
         self.data = data[0]
         self.assertEqual(self.data.filename, filename)
@@ -304,5 +381,5 @@
         """
         filename = "cansas1d_badunits.xml"
-        data = Loader().load(filename)
+        data = CANSASReader().read(filename)
         self.data = data[0]
         self.assertEqual(self.data.filename, filename)
@@ -311,7 +388,7 @@
         # This one should
         self.assertAlmostEqual(self.data.sample.transmission, 0.327)
-        
+
         self.assertEqual(self.data.meta_data['loader'], "CanSAS XML 1D")
-        print self.data.errors
+        print(self.data.errors)
         self.assertEqual(len(self.data.errors), 1)
 
@@ -321,9 +398,9 @@
         """
         filename = "cansas1d_slit.xml"
-        data = Loader().load(filename)
+        data = CANSASReader().read(filename)
         self.data = data[0]
         self.assertEqual(self.data.filename, filename)
         self.assertEqual(self.data.run[0], "1234")
-        
+
         # Data
         self.assertEqual(len(self.data.x), 2)
Index: test/sasdataloader/test/utest_averaging.py
===================================================================
--- test/sasdataloader/test/utest_averaging.py	(revision 8ffafd1261e10b3f4556af59ce0dfbe8c7d78c3e)
+++ test/sasdataloader/test/utest_averaging.py	(revision e123eb9d95fae313c2ba30fd80c75cbd20c17c56)
@@ -1,10 +1,16 @@
 
 import math
+import os
 import unittest
+from scipy.stats import binned_statistic_2d
 import numpy as np
+
 import sas.sascalc.dataloader.data_info as data_info
 from sas.sascalc.dataloader.loader import Loader
-from sas.sascalc.dataloader.manipulations import Boxsum, Boxavg, Ring, get_q,\
-    CircularAverage, SectorPhi, SectorQ, reader2D_converter, SlabX, SlabY
+from sas.sascalc.dataloader.manipulations import (Boxavg, Boxsum,
+                                                  CircularAverage, Ring,
+                                                  SectorPhi, SectorQ, SlabX,
+                                                  SlabY, get_q,
+                                                  reader2D_converter)
 
 
@@ -13,4 +19,5 @@
         Test averaging manipulations on a flat distribution
     """
+
     def setUp(self):
         """
@@ -18,37 +25,38 @@
             should return the predefined height of the distribution (1.0).
         """
-        x_0 = np.ones([100,100])
-        dx_0 = np.ones([100,100])
+        x_0 = np.ones([100, 100])
+        dx_0 = np.ones([100, 100])
 
         self.data = data_info.Data2D(data=x_0, err_data=dx_0)
         detector = data_info.Detector()
         detector.distance = 1000.0  # mm
-        detector.pixel_size.x = 1.0 # mm
-        detector.pixel_size.y = 1.0 # mm
+        detector.pixel_size.x = 1.0  # mm
+        detector.pixel_size.y = 1.0  # mm
 
         # center in pixel position = (len(x_0)-1)/2
-        detector.beam_center.x = (len(x_0)-1)/2 # pixel number
-        detector.beam_center.y = (len(x_0)-1)/2 # pixel number
+        detector.beam_center.x = (len(x_0) - 1) / 2  # pixel number
+        detector.beam_center.y = (len(x_0) - 1) / 2  # pixel number
         self.data.detector.append(detector)
-        
+
         source = data_info.Source()
-        source.wavelength = 10.0 # A
+        source.wavelength = 10.0  # A
         self.data.source = source
 
-        # get_q(dx, dy, det_dist, wavelength) where units are mm, mm, mm, and A
+        # get_q(dx, dy, det_dist, wavelength) where units are mm,mm,mm,and A
+        # respectively.
         self.qmin = get_q(1.0, 1.0, detector.distance, source.wavelength)
         self.qmax = get_q(49.5, 49.5, detector.distance, source.wavelength)
 
         self.qstep = len(x_0)
-        x=  np.linspace(start= -1*self.qmax,
-                               stop= self.qmax,
-                               num= self.qstep,
-                               endpoint=True )  
-        y = np.linspace(start= -1*self.qmax,
-                               stop= self.qmax,
-                               num= self.qstep,
-                               endpoint=True )
-        self.data.x_bins=x
-        self.data.y_bins=y
+        x = np.linspace(start=-1 * self.qmax,
+                        stop=self.qmax,
+                        num=self.qstep,
+                        endpoint=True)
+        y = np.linspace(start=-1 * self.qmax,
+                        stop=self.qmax,
+                        num=self.qstep,
+                        endpoint=True)
+        self.data.x_bins = x
+        self.data.y_bins = y
         self.data = reader2D_converter(self.data)
 
@@ -57,6 +65,6 @@
             Test ring averaging
         """
-        r = Ring(r_min=2*self.qmin, r_max=5*self.qmin, 
-                 center_x=self.data.detector[0].beam_center.x, 
+        r = Ring(r_min=2 * self.qmin, r_max=5 * self.qmin,
+                 center_x=self.data.detector[0].beam_center.x,
                  center_y=self.data.detector[0].beam_center.y)
         r.nbins_phi = 20
@@ -70,6 +78,6 @@
             Test sector averaging
         """
-        r = SectorPhi(r_min=self.qmin, r_max=3*self.qmin, 
-                      phi_min=0, phi_max=math.pi*2.0)
+        r = SectorPhi(r_min=self.qmin, r_max=3 * self.qmin,
+                      phi_min=0, phi_max=math.pi * 2.0)
         r.nbins_phi = 20
         o = r(self.data)
@@ -81,5 +89,5 @@
         """
         phi_max = math.pi * 1.5
-        r = SectorPhi(r_min=self.qmin, r_max=3*self.qmin, 
+        r = SectorPhi(r_min=self.qmin, r_max=3 * self.qmin,
                       phi_min=0, phi_max=phi_max)
         self.assertEqual(r.phi_max, phi_max)
@@ -94,5 +102,7 @@
 
     def setUp(self):
-        self.data = Loader().load('MAR07232_rest.ASC')
+        filepath = os.path.join(os.path.dirname(
+            os.path.realpath(__file__)), 'MAR07232_rest.ASC')
+        self.data = Loader().load(filepath)
 
     def test_ring(self):
@@ -100,13 +110,14 @@
             Test ring averaging
         """
-        r = Ring(r_min=.005, r_max=.01, 
-                 center_x=self.data.detector[0].beam_center.x, 
+        r = Ring(r_min=.005, r_max=.01,
+                 center_x=self.data.detector[0].beam_center.x,
                  center_y=self.data.detector[0].beam_center.y,
-                 nbins = 20)
-        # r.nbins_phi = 20
-
-        o = r(self.data)
-        data_list = Loader().load('ring_testdata.txt')
-        answer = data_list[0]
+                 nbins=20)
+        ##r.nbins_phi = 20
+
+        o = r(self.data)
+        filepath = os.path.join(os.path.dirname(
+            os.path.realpath(__file__)), 'ring_testdata.txt')
+        answer = Loader().load(filepath)
 
         for i in range(r.nbins_phi - 1):
@@ -115,31 +126,34 @@
             self.assertAlmostEqual(o.dy[i + 1], answer.dy[i], 4)
 
-    def test_circular_avg(self):
+    def test_circularavg(self):
+        """
+        Test circular averaging
+        The test data was not generated by IGOR.
+        """
+        r = CircularAverage(r_min=.00, r_max=.025,
+                            bin_width=0.0003)
+        r.nbins_phi = 20
+
+        o = r(self.data)
+
+        filepath = os.path.join(os.path.dirname(
+            os.path.realpath(__file__)), 'avg_testdata.txt')
+        answer = Loader().load(filepath)
+        for i in range(r.nbins_phi):
+            self.assertAlmostEqual(o.x[i], answer.x[i], 4)
+            self.assertAlmostEqual(o.y[i], answer.y[i], 4)
+            self.assertAlmostEqual(o.dy[i], answer.dy[i], 4)
+
+    def test_box(self):
         """
             Test circular averaging
             The test data was not generated by IGOR.
         """
-        r = CircularAverage(r_min=.00, r_max=.025, 
-                 bin_width=0.0003)
-        r.nbins_phi = 20
-        o = r(self.data)
-
-        output = Loader().load('avg_testdata.txt')
-        answer = output[0]
-        for i in range(r.nbins_phi):
-            self.assertAlmostEqual(o.x[i], answer.x[i], 4)
-            self.assertAlmostEqual(o.y[i], answer.y[i], 4)
-            self.assertAlmostEqual(o.dy[i], answer.dy[i], 4)
-
-    def test_box(self):
-        """
-            Test circular averaging
-            The test data was not generated by IGOR.
-        """
+
         r = Boxsum(x_min=.01, x_max=.015, y_min=0.01, y_max=0.015)
         s, ds, npoints = r(self.data)
         self.assertAlmostEqual(s, 34.278990899999997, 4)
         self.assertAlmostEqual(ds, 7.8007981835194293, 4)
-        self.assertAlmostEqual(npoints, 324.0000, 4)        
+        self.assertAlmostEqual(npoints, 324.0000, 4)
 
         r = Boxavg(x_min=.01, x_max=.015, y_min=0.01, y_max=0.015)
@@ -153,10 +167,13 @@
             The test data was not generated by IGOR.
         """
-        r = SlabX(x_min=-.01, x_max=.01, y_min=-0.0002, y_max=0.0002, bin_width=0.0004)
+
+        r = SlabX(x_min=-.01, x_max=.01, y_min=-0.0002,
+                  y_max=0.0002, bin_width=0.0004)
         r.fold = False
         o = r(self.data)
 
-        output = Loader().load('slabx_testdata.txt')
-        answer = output[0]
+        filepath = os.path.join(os.path.dirname(
+            os.path.realpath(__file__)), 'slabx_testdata.txt')
+        answer = Loader().load(filepath)
         for i in range(len(o.x)):
             self.assertAlmostEqual(o.x[i], answer.x[i], 4)
@@ -169,10 +186,13 @@
             The test data was not generated by IGOR.
         """
-        r = SlabY(x_min=.005, x_max=.01, y_min=-0.01, y_max=0.01, bin_width=0.0004)
+
+        r = SlabY(x_min=.005, x_max=.01, y_min=-
+                  0.01, y_max=0.01, bin_width=0.0004)
         r.fold = False
         o = r(self.data)
 
-        output = Loader().load('slaby_testdata.txt')
-        answer = output[0]
+        filepath = os.path.join(os.path.dirname(
+            os.path.realpath(__file__)), 'slaby_testdata.txt')
+        answer = Loader().load(filepath)
         for i in range(len(o.x)):
             self.assertAlmostEqual(o.x[i], answer.x[i], 4)
@@ -183,8 +203,9 @@
         """
             Test sector averaging I(phi)
-            When considering the whole azimuthal range (2pi), 
+            When considering the whole azimuthal range (2pi),
             the answer should be the same as ring averaging.
             The test data was not generated by IGOR.
         """
+
         nbins = 19
         phi_min = math.pi / (nbins + 1)
@@ -198,11 +219,12 @@
         o = r(self.data)
 
-        output = Loader().load('ring_testdata.txt')
-        answer = output[0]
-        for i in range(len(o.x)):
-            self.assertAlmostEqual(o.x[i], answer.x[i], 4)
-            self.assertAlmostEqual(o.y[i], answer.y[i], 4)
-            self.assertAlmostEqual(o.dy[i], answer.dy[i], 4)
-            
+        filepath = os.path.join(os.path.dirname(
+            os.path.realpath(__file__)), 'ring_testdata.txt')
+        answer = Loader().load(filepath)
+        for i in range(len(o.x)):
+            self.assertAlmostEqual(o.x[i], answer.x[i], 4)
+            self.assertAlmostEqual(o.y[i], answer.y[i], 4)
+            self.assertAlmostEqual(o.dy[i], answer.dy[i], 4)
+
     def test_sectorphi_quarter(self):
         """
@@ -210,15 +232,17 @@
             The test data was not generated by IGOR.
         """
-        r = SectorPhi(r_min=.005, r_max=.01, phi_min=0, phi_max=math.pi/2.0)
-        r.nbins_phi = 20
-        o = r(self.data)
-
-        output = Loader().load('sectorphi_testdata.txt')
-        answer = output[0]
-        for i in range(len(o.x)):
-            self.assertAlmostEqual(o.x[i], answer.x[i], 4)
-            self.assertAlmostEqual(o.y[i], answer.y[i], 4)
-            self.assertAlmostEqual(o.dy[i], answer.dy[i], 4)
-            
+
+        r = SectorPhi(r_min=.005, r_max=.01, phi_min=0, phi_max=math.pi / 2.0)
+        r.nbins_phi = 20
+        o = r(self.data)
+
+        filepath = os.path.join(os.path.dirname(
+            os.path.realpath(__file__)), 'sectorphi_testdata.txt')
+        answer = Loader().load(filepath)
+        for i in range(len(o.x)):
+            self.assertAlmostEqual(o.x[i], answer.x[i], 4)
+            self.assertAlmostEqual(o.y[i], answer.y[i], 4)
+            self.assertAlmostEqual(o.dy[i], answer.dy[i], 4)
+
     def test_sectorq_full(self):
         """
@@ -226,14 +250,47 @@
             The test data was not generated by IGOR.
         """
-        r = SectorQ(r_min=.005, r_max=.01, phi_min=0, phi_max=math.pi/2.0)
-        r.nbins_phi = 20
-        o = r(self.data)
-
-        output = Loader().load('sectorq_testdata.txt')
-        answer = output[0]
-        for i in range(len(o.x)):
-            self.assertAlmostEqual(o.x[i], answer.x[i], 4)
-            self.assertAlmostEqual(o.y[i], answer.y[i], 4)
-            self.assertAlmostEqual(o.dy[i], answer.dy[i], 4)
+
+        r = SectorQ(r_min=.005, r_max=.01, phi_min=0, phi_max=math.pi / 2.0)
+        r.nbins_phi = 20
+        o = r(self.data)
+
+        filepath = os.path.join(os.path.dirname(
+            os.path.realpath(__file__)), 'sectorq_testdata.txt')
+        answer = Loader().load(filepath)
+        for i in range(len(o.x)):
+            self.assertAlmostEqual(o.x[i], answer.x[i], 4)
+            self.assertAlmostEqual(o.y[i], answer.y[i], 4)
+            self.assertAlmostEqual(o.dy[i], answer.dy[i], 4)
+
+    def test_sectorq_log(self):
+        """
+            Test sector averaging I(q)
+            The test data was not generated by IGOR.
+        """
+
+        r = SectorQ(r_min=.005, r_max=.01, phi_min=0, phi_max=math.pi / 2.0, base=10)
+        r.nbins_phi = 20
+        o = r(self.data)
+
+        expected_binning = np.logspace(np.log10(0.005), np.log10(0.01), 20, base=10)
+        for i in range(len(o.x)):
+            self.assertAlmostEqual(o.x[i], expected_binning[i], 3)
+
+        # TODO: Test for Y values (o.y)
+        # print len(self.data.x_bins)
+        # print len(self.data.y_bins)
+        # print self.data.q_data.shape
+        # data_to_bin = np.array(self.data.q_data)
+        # data_to_bin = data_to_bin.reshape(len(self.data.x_bins), len(self.data.y_bins))
+        # H, xedges, yedges, binnumber = binned_statistic_2d(self.data.x_bins, self.data.y_bins, data_to_bin,
+        #     bins=[[0, math.pi / 2.0], expected_binning], statistic='mean')
+        # xedges_width = (xedges[1] - xedges[0])
+        # xedges_center = xedges[1:] - xedges_width / 2
+
+        # yedges_width = (yedges[1] - yedges[0])
+        # yedges_center = yedges[1:] - yedges_width / 2
+
+        # print H.flatten().shape
+        # print o.y.shape
 
 
